
/*
 little of this sketch is mine.  Thanks to the guys on the arduino forum for
 putting up with me for the months I was working this out.
 Fantastic help I could nevver have succeeded without, never mind
 even get past base one.

 The sketch is also designed around a singular design of sub that has
 attributes that are pretty unique

 changed knob to trim
 changed Aux to piston
 added control


 ADJUSTMENTS
 PID config for depth keeping  41, 203
 wait time for controls 97
 Piston control for depth keeping  51, 52
 Manual relay timing  100
 Hydro acutator movement  203
 Surface and dive routines and timing 342-3876
 
 
 
 
 
 
 
 
 
 */


#include <PinChangeInt.h>
#include <Servo.h>
#include <PID_v1.h>

///////////////////////////////////////////////////////////
double cruisedepth; // “setpoint” for pid
double wpressure = A0; // sensor MPXV7007G “input”
double deep;// variable
double output;
char Direction;
PID myPID(&wpressure, &output, &deep, 120, 0, 0, Direction); // key numbers for PID
Servo hydroplane;
int actuator;


// period for periodic adjustment of the piston during depth keep mode
const unsigned long StartInterval = 5000;
const unsigned long OnInterval = 1000;
boolean RelayIsOn = true;
unsigned long LastStartTime = 0;
unsigned long LastOnTime = 0;
int depthkeeppistontrigger;

// Assign RC channels to input pins
#define BALLAST_IN_PIN 3 //receiver channel 8  (brown wire) also connected to reset servo
#define TRIM_IN_PIN 2  //receiver channel 7 (orange wire)  
#define PISTON_IN_PIN 4  // receiver channel 4 (black)          
#define HYDRO_IN_PIN 5 //receiver cahnnel 3 (green wire)      
#define CONTROL_IN_PIN 12 //  receiver channel 5 (red wire)
#define ROUTINE_IN_PIN A5 // receiver channel 6 (white wire)

// Assign channel out pins for servos
#define HYDRO_OUT_PIN 13 // this is live
#define HYDRO_OFF_PIN A3 //  this is a dead end
#define RETRACT_SERVO_PIN A2       // Assigning channel out pin for connection  retract servo
#define SERVO_POWER_PIN A1       // Assigning channel out pin for connection  to relay for hydro
#define POWER_RETRACT_SERVO_PIN A4 // Assigning channel out pin for connection  relayfor retract servo 

// Assigned channel out pins for connection  to relays
int PISTON_DIVE_PIN = 6; // relay 8 yellow
int PISTON_SURFACE_PIN = 7; // relay 7 orange
int PUMP_DIVE_PIN = 9; // relay 6 brown
int PUMP_SURFACE_PIN = 8; //relay 5 white
int TRIM_TO_BOW_PIN = 10; //relay 4 yellow
int TRIM_TO_STERN_PIN = 11; //relay 3 green
//int SERVO_POWER_PIN = A1; // power to the servo power realay

//  INTEGERS CALLED TO ENSURE THAT VARIOUS FUNCTIONS DO NOT CLASH
int Pistondivemanual;
int Pistonsurfacedepthkeep;
int Pistondivedepthkeep;
int Trimtobowmanual;
int Trimtosternmanual;
int Pumpdivemanual;
int Pumpsurfacemanual;
int Pistonsurfacemanual;
int Pistonsurfacefailsafe;

// set up for averaging out depth readings to make them smoother
const int numReadings = 10;
int readings[numReadings];      // the readings from the analog input
int index = 0;                  // the index of the current reading
int total = 0;                  // the running total
int averagedepth = 0;           // the average
int pressurePin = A0;           // in pin for pressure gauge
int depthsnapshot = 0;          // snapshot depth


// individual timing gaps for the following functions.
const unsigned long PISTON_DIVE_PINinterval = 10;
const unsigned long PISTON_SURFACE_PINinterval = 10;
const unsigned long PUMP_DIVE_PINinterval = 1000;
const unsigned long PUMP_SURFACE_PINinterval = 1000;
const unsigned long TRIM_TO_BOW_PINinterval = 10;
const unsigned long TRIM_TO_STERN_PINinterval = 10;


unsigned long PISTON_DIVE_PINtimer;
unsigned long PISTON_SURFACE_PINtimer;
unsigned long PUMP_DIVE_PINtimer;
unsigned long PUMP_SURFACE_PINtimer;
unsigned long TRIM_TO_BOW_PINtimer;
unsigned long TRIM_TO_STERN_PINtimer;

// this example code provides a straight pass through of the signal with no custom processing
Servo servoBallast;
Servo servoTrim;
Servo servoPiston;
Servo servoHydro;
Servo servoControl;
Servo servoRoutine;
Servo servoPlaneretract;   // output to Planeretract servo ballast from arduino

int pos = 1100;            //  set the starting point for the servo in microseconds
int retraction = 0;        //  int to start the retraction, only when wanted.  Goes to '1' when triggered
int extendpos = 1800;      //  set the upper point for the servo in microseconds
int retractionpos = 1100;  //  set the lower point for the servo in microseconds.  Same as start for pos
int evenpos = 1500;        //  set the flat or level point for hydroplane

// all to do with reading servos.
//These bit flags are set in bUpdateFlagsShared to indicate which
#define BALLAST_FLAG 1
#define TRIM_FLAG 2
#define PISTON_FLAG 3
#define HYDRO_FLAG 4
#define CONTROL_FLAG 5
#define ROUTINE_FLAG 6

// holds the update flags defined above
volatile uint8_t bUpdateFlagsShared;
volatile uint16_t unBallastInShared;
volatile uint16_t unTrimInShared;
volatile uint16_t unPistonInShared;
volatile uint16_t unHydroInShared;
volatile uint16_t unControlInShared;
volatile uint16_t unRoutineInShared;

uint32_t ulBallastStart;
uint32_t ulTrimStart;
uint32_t ulPistonStart;
uint32_t ulHydroStart;
uint32_t ulControlStart;
uint32_t ulRoutineStart;

// defining the routines to surface and dive the sub.
int DIVEROUTINE;
int SURFACEROUTINE1;
int SURFACEROUTINE2;
int pressureValue;



void setup()
{
  Serial.begin(9600);

  //pressure sensor stuff
  // initialize all the readings to 0:
  // this sets up aveage readings for pressure sensor
  for (int thisReading = 0; thisReading < numReadings; thisReading++)
    readings[thisReading] = 0;


  pinMode(PISTON_DIVE_PIN, OUTPUT);
  pinMode(PISTON_SURFACE_PIN, OUTPUT);
  pinMode(PUMP_DIVE_PIN, OUTPUT);
  pinMode(PUMP_SURFACE_PIN, OUTPUT);
  pinMode(TRIM_TO_BOW_PIN, OUTPUT);
  pinMode(TRIM_TO_STERN_PIN, OUTPUT);
  pinMode(SERVO_POWER_PIN, OUTPUT);
  pinMode(A5, INPUT);
  pinMode(POWER_RETRACT_SERVO_PIN, OUTPUT);
  
  //servoHydro.attach(HYDRO_OUT_PIN);               //already there      //  attaching servo instructions to the servos
  //servoBallast.attach(BALLAST_OUT_PIN);
  servoPlaneretract.attach(RETRACT_SERVO_PIN);
  
  //  following routine in setup does a one off set up rouine.  
  
  //digitalWrite(SERVO_POWER_PIN, LOW);                   // turns on the hydroplane relay (note for these realys low is on and high is off. can get both sorts
  digitalWrite(POWER_RETRACT_SERVO_PIN, LOW);           // turns on the retract servo
  delay (1000);                                         // gives the servo a moment
  servoPlaneretract.writeMicroseconds(retractionpos);   // sets the retract servo to open at the start of every session.  
  delay (1000);                                         // gives servo a little time to travel
  digitalWrite(POWER_RETRACT_SERVO_PIN, HIGH);          //  turns off the retract servo relay


  // timer for functions
  PISTON_DIVE_PINtimer = millis ();
  PISTON_SURFACE_PINtimer = millis ();
  PUMP_DIVE_PINtimer = millis ();
  PUMP_SURFACE_PINtimer = millis ();
  TRIM_TO_BOW_PINtimer = millis ();
  TRIM_TO_STERN_PINtimer = millis ();


  (DIVEROUTINE = 0);  //define constant state.  when triggered will go to 1
  (SURFACEROUTINE1 = 0);
  (SURFACEROUTINE2 = 0);


  // using the PinChangeInt library, attach the interrupts
  // used to read the channels
  PCintPort::attachInterrupt(BALLAST_IN_PIN, calcBallast, CHANGE);
  PCintPort::attachInterrupt(TRIM_IN_PIN, calcTrim, CHANGE);
  PCintPort::attachInterrupt(PISTON_IN_PIN, calcPiston, CHANGE);
  PCintPort::attachInterrupt(HYDRO_IN_PIN, calcHydro, CHANGE);
  PCintPort::attachInterrupt(CONTROL_IN_PIN, calcControl, CHANGE);
  PCintPort::attachInterrupt(ROUTINE_IN_PIN, calcRoutine, CHANGE);

  // more PID stuff for depth keeping
  pinMode(A0, INPUT); // sensor MPXV7007G
  myPID.SetMode(AUTOMATIC); // pone en marcha el PID
  myPID.SetOutputLimits(0.0, 40.0); // 0.0, 40.0)  70, 110)
  myPID.SetSampleTime(80);//80ms

}


void loop()
{
  //////////// settin gp pid to work with depthsnapshot
  cruisedepth = depthsnapshot * 5.0 / 1023;
  wpressure = analogRead(A0) * 5.0 / 1023; //
  deep = cruisedepth; // don't get this
  if (wpressure > deep)
  {
    myPID.SetControllerDirection(REVERSE);
    myPID.Compute(); //
    output = output * -1;
  }
  if (wpressure <= deep)
  {
    myPID.SetControllerDirection(DIRECT);
    myPID.Compute(); //
    output = output * 1;
  }
  actuator = map(output, -10, 10, 1300, 1700); //
  hydroplane.writeMicroseconds(actuator);

  

  // Hold local copies of the channel inputs
  static uint16_t unBallastIn;
  static uint16_t unTrimIn;
  static uint16_t unPistonIn;
  static uint16_t unHydroIn;
  static uint16_t unControlIn;
  static uint16_t unRoutineIn;

  // local copy of update flags
  static uint8_t bUpdateFlags;



  // Serial.println(unBallastIn); // prining whichever needed for review as required
  // Serial.println(unTrimIn);
  // Serial.println(averagedepth);
  // Serial.println(unRoutineIn);
  // Serial.println(unPistonIn);
  //Serial.println(unHydroIn);
  // Serial.println(unControlIn);
  // Serial.println(FailsafeMode);
  // Serial.println(BadSignalDetected);
  // Serial.println(pistonsurfacefailsafe);  //this freezes currently
  //Serial.println(unBallastIn);


  ///////////////////////// the following runs the averaging routine for the pressure sensor
  // subtract the last reading:
  total = total - readings[index];
  // read from the sensor:
  readings[index] = analogRead(pressurePin);
  // add the reading to the total:
  total = total + readings[index];
  // advance to the next position in the array:
  index = index + 1;
  // if we're at the end of the array...
  if (index >= numReadings)
    // ...wrap around to the beginning:
    index = 0;                            // calculate the average:
  averagedepth = total / numReadings;
  // send it to the computer as ASCII digits
  // delay(100);        // delay in between reads for stability



  //////////////////////////  trigger depth snapshot
  if (unControlIn > 1800)
  {
    depthsnapshot = averagedepth; // as sugggested we have a snapshot
  }


  /////////////////////////// swap between hydro and depth keeping
  if (unControlIn > 1145)
  {
    servoHydro.attach(HYDRO_OUT_PIN);
    hydroplane.attach(A3);
  }
  if (unControlIn < 1145)
  {
    servoHydro.attach(HYDRO_OFF_PIN);
    hydroplane.attach(13);
    delay(150);
  }

if (unBallastIn < 1200)        //  this is the reading from the ballast channel.  When under 1200 it triggers the process
  {
    retraction = 1;               // trigger for retraction
  } 
  else if (unBallastIn >= 1200)   // opposite
  {
   retraction = 0;                // retraction off
  }


  if ((retraction == 1) && ( extendpos > pos))     //if retract is '1' and the current position is less than the max position 
    {      
     digitalWrite(POWER_RETRACT_SERVO_PIN, LOW);   //  turn on the retract servo relay
     (pos = pos + 1);                              //  let the position increase in increments of 1 'microseconds')
     delay (15);                                   //  speed of increase
     servoPlaneretract.writeMicroseconds(pos);     //  write the changing 'pos' to the servo           
     digitalWrite(POWER_RETRACT_SERVO_PIN, HIGH);  //  keeps the relay off 
    }


 if ((retraction == 0)&& ( retractionpos < pos))   //if retract and position less than 150, then 
    {
    digitalWrite(POWER_RETRACT_SERVO_PIN, LOW);
    (pos = pos - 1);                               //  let the position increase in increments of 1
    delay (15);                                    //  speed of increase
    servoPlaneretract.writeMicroseconds(pos);
    servoPlaneretract.write(pos);                  //  write this to the plane
    digitalWrite(POWER_RETRACT_SERVO_PIN, HIGH);   //  keeps the relay off
  }
  
  
  if (pos >= (retractionpos+10))                    // If the position of the retract servo, or the pos that drives it, 
                                                   //  is above level, turn the hydro realy off.  May not need the '10'
  {
    digitalWrite(SERVO_POWER_PIN, HIGH);    
  }
  else
  {
    digitalWrite(SERVO_POWER_PIN, LOW);
  }

  
  // periodic adjustment of the piston
  // when in depth keeping mode
  {
    if (RelayIsOn) {
      if (millis() - LastOnTime > OnInterval) {
        RelayIsOn = false;
        depthkeeppistontrigger = 0;
      }
    }
    else {  // Relay is off
      if (millis() - LastStartTime > StartInterval) {
        RelayIsOn = true;
        LastOnTime = millis();
        depthkeeppistontrigger = 1;
        LastStartTime = millis();
      }
    }
    if (depthkeeppistontrigger == 1 && (averagedepth + 30) < depthsnapshot && unControlIn < 1145)
    {
      Pistondivedepthkeep = 1;
    }
    else
    {
      Pistondivedepthkeep = 0;
    }
  }

  if (depthkeeppistontrigger == 1 && (averagedepth - 30) > depthsnapshot && unControlIn < 1145)
  {
    Pistonsurfacedepthkeep = 1;
  }
  else
  {
    Pistonsurfacedepthkeep = 0;
  }



  // SURFACE ROUTINE TRIGGERED BY SURFACEROUTINE1 and 2
  // s'routine1 causes the boat to rise.
  // s'routine 2 only turns on after 1 is finished, and when the boat is at the surface
  // the routine is broken down into sections controlled by equal delays to avoid delay causing chaos.


  if (SURFACEROUTINE1 == 1)
  {
    digitalWrite(TRIM_TO_STERN_PIN, HIGH); // small delay
    digitalWrite(PISTON_SURFACE_PIN, HIGH);
    digitalWrite(PUMP_SURFACE_PIN, HIGH);
    delay(600);
    digitalWrite(TRIM_TO_STERN_PIN, LOW); // trim to stern 4 seconds
    digitalWrite(PISTON_SURFACE_PIN, LOW); // piston out 4 seconds
    digitalWrite(PUMP_SURFACE_PIN, HIGH);   // pump not activates by s'routine 1
    delay(12000);
    (SURFACEROUTINE1 = 0);
  }

  if (SURFACEROUTINE2 == 1 && averagedepth < 600 && SURFACEROUTINE1 == 0)  // s'routine 2 only starts now
  {
    digitalWrite(TRIM_TO_STERN_PIN, HIGH); // small delay
    digitalWrite(PISTON_SURFACE_PIN, HIGH);
    digitalWrite(PUMP_SURFACE_PIN, HIGH);
    delay(2000);
    digitalWrite(TRIM_TO_STERN_PIN, HIGH);
    digitalWrite(PISTON_SURFACE_PIN, HIGH);
    digitalWrite(PUMP_SURFACE_PIN, LOW);  // pump out starts for long haul empty
    delay(30000);
    (SURFACEROUTINE2 = 0);
  }




  //  DIVEROUTINE TRIGGERED BY DOUBLE CLICK DIVE

  if (DIVEROUTINE == 1)
  {
    digitalWrite(TRIM_TO_BOW_PIN, HIGH); // little delay
    digitalWrite(PISTON_DIVE_PIN, HIGH);
    digitalWrite(PUMP_DIVE_PIN, HIGH);
    delay(600);
    digitalWrite(TRIM_TO_BOW_PIN, LOW); // 10 second trim to bow
    digitalWrite(PISTON_DIVE_PIN, LOW); // 10 second piston withdraw
    digitalWrite(PUMP_DIVE_PIN, HIGH);
    delay(12000);
    digitalWrite(TRIM_TO_BOW_PIN, HIGH);
    digitalWrite(PISTON_DIVE_PIN, HIGH);
    digitalWrite(PUMP_DIVE_PIN, LOW);  // pump completes
    delay(18000);
    (DIVEROUTINE = 0);
  }

  // turn on servo power so that it doesn't go crazy during boot up
  //close them down when in failsafe mode


  //PISTON PARAMETERS for manual relay action

  if (unPistonIn < 1300)
  {
    if ( (millis () - PISTON_DIVE_PINtimer) >= PISTON_DIVE_PINinterval)
      Pistondivemanual = 1;
  }
  else if (unPistonIn > 1300)
  {
    Pistondivemanual = 0;
    PISTON_DIVE_PINtimer = millis ();

  }


  if (unPistonIn > 1800)
  {
    if ( (millis () - PISTON_SURFACE_PINtimer) >= PISTON_SURFACE_PINinterval)
      Pistonsurfacemanual = 1;
  }
  else if (unPistonIn < 1800)
  {
    Pistonsurfacemanual = 0;
    PISTON_SURFACE_PINtimer = millis ();
  }


  // BALLAST PUMP PARAMETERS

  if (unBallastIn < 1390)
  {
    if ( (millis () - PUMP_DIVE_PINtimer) >= PUMP_DIVE_PINinterval)
      Pumpdivemanual = 1;
  }
  else if (unBallastIn > 1390)
  {
    Pumpdivemanual = 0;
    PUMP_DIVE_PINtimer = millis ();
  }
  if (unBallastIn < 1100)
  {
    Pumpdivemanual = 0;

  }


  if (unBallastIn > 1620)
  {
    if ( (millis () - PUMP_SURFACE_PINtimer) >= PUMP_SURFACE_PINinterval)
      Pumpsurfacemanual = 1;
  }
  else if (unBallastIn < 1620)
  {
    Pumpsurfacemanual = 0;
    PUMP_SURFACE_PINtimer = millis ();
  }
  if (unBallastIn > 1890)
  {
    Pumpsurfacemanual = 0;
  }



  // trim to bow relay

  if (unTrimIn < 1345)
  {
    if ( (millis () - TRIM_TO_BOW_PINtimer) >= TRIM_TO_BOW_PINinterval)
      Trimtobowmanual = 1;
  }
  else if (unTrimIn > 1345)
  {
    Trimtobowmanual = 0;
    TRIM_TO_BOW_PINtimer = millis ();
  }


  // trim to stern switch

  if (unTrimIn > 1680)
  {
    if ( (millis () - TRIM_TO_STERN_PINtimer) >= TRIM_TO_STERN_PINinterval)
      Trimtosternmanual = 1;
  }
  else if (unTrimIn < 1680)
  {
    Trimtosternmanual = 0;
    TRIM_TO_STERN_PINtimer = millis ();
  }




  // sorting the commands to the relays
  //  so they don't clash

  if (Pistonsurfacemanual == 1 || Pistonsurfacedepthkeep == 1)
  {
    digitalWrite(PISTON_SURFACE_PIN, LOW);
  }
  else
  {
    digitalWrite(PISTON_SURFACE_PIN, HIGH);
  }

  if (Pistondivemanual == 1 || Pistondivedepthkeep == 1)
  {
    digitalWrite(PISTON_DIVE_PIN, LOW);
  }
  else
  {
    digitalWrite(PISTON_DIVE_PIN, HIGH);
  }


  if (Trimtobowmanual == 1)
  {
    digitalWrite(TRIM_TO_BOW_PIN, LOW);
  }
  else
  {
    digitalWrite(TRIM_TO_BOW_PIN, HIGH);
  }

  if (Trimtosternmanual == 1)
  {
    digitalWrite(TRIM_TO_STERN_PIN, LOW);
  }
  else
  {
    digitalWrite(TRIM_TO_STERN_PIN, HIGH);
  }


  if (Pumpsurfacemanual == 1)
  {
    digitalWrite(PUMP_SURFACE_PIN, LOW);
  }
  else
  {
    digitalWrite(PUMP_SURFACE_PIN, HIGH);
  }

  if (Pumpdivemanual == 1)
  {
    digitalWrite(PUMP_DIVE_PIN, LOW);
  }
  else
  {
    digitalWrite(PUMP_DIVE_PIN, HIGH);
  }



  // check shared update flags to see if any channels have a new signal
  if (bUpdateFlagsShared)
  {

    noInterrupts(); // turn interrupts off quickly while we take local copies of the shared variables

    // take a local copy of which channels were updated in case we need to use this in the rest of loop
    bUpdateFlags = bUpdateFlagsShared;


    if (bUpdateFlags & BALLAST_FLAG)
    {
      unBallastIn = unBallastInShared;
    }

    if (bUpdateFlags & TRIM_FLAG)
    {
      unTrimIn = unTrimInShared;
    }

    if (bUpdateFlags & PISTON_FLAG)
    {
      unPistonIn = unPistonInShared;
    }

    if (bUpdateFlags & HYDRO_FLAG)
    {
      unHydroIn = unHydroInShared;
    }
    if (bUpdateFlags & CONTROL_FLAG)
    {
      unControlIn = unControlInShared;
    }
    if (bUpdateFlags & ROUTINE_FLAG)
    {
      unRoutineIn = unRoutineInShared;
    }

    // clear shared copy of updated flags as have already taken the updates
    // have a local copy if we need to use it in bUpdateFlags
    bUpdateFlagsShared = 0;

    interrupts(); // turn interrupts back on

  }

  //  Initiate dive routine
  if (unRoutineIn > 2000)
    //delay(500);
  {
    (DIVEROUTINE = 1);
  }
  if (unRoutineIn < 1800)
  {
    (DIVEROUTINE = 0);
  }

  //  Initiate surface routine
  if (unRoutineIn < 1000)
    //delay(500);
  {
    (SURFACEROUTINE1 = 1);
    (SURFACEROUTINE2 = 1);
  }
  if (unRoutineIn > 1300)
  {
    (SURFACEROUTINE1 = 0);
    (SURFACEROUTINE2 = 0);
  }



  // on every cycle.
  if (bUpdateFlags & BALLAST_FLAG)
  {
    if (servoBallast.readMicroseconds() != unBallastIn)
    {
      servoBallast.writeMicroseconds(unBallastIn);
    }

  }

  if (bUpdateFlags & TRIM_FLAG)
  {
    if (servoTrim.readMicroseconds() != unTrimIn)
    {
      servoTrim.writeMicroseconds(unTrimIn);
    }
  }

  if (bUpdateFlags & PISTON_FLAG)
  {
    if (servoPiston.readMicroseconds() != unPistonIn)
    {
      servoPiston.writeMicroseconds(unPistonIn);
    }
  }

  if (bUpdateFlags & HYDRO_FLAG)
  {
    if (servoHydro.readMicroseconds() != unHydroIn)
    {
      servoHydro.writeMicroseconds(unHydroIn);
    }
  }

  if (bUpdateFlags & CONTROL_FLAG)
  {
    if (servoControl.readMicroseconds() != unControlIn)
    {
      servoControl.writeMicroseconds(unControlIn);
    }
  }
  if (bUpdateFlags & ROUTINE_FLAG)
  {
    if (servoRoutine.readMicroseconds() != unRoutineIn)
    {
      servoRoutine.writeMicroseconds(unRoutineIn);
    }
  }
  bUpdateFlags = 0;

}



// simple interrupt service routine
void calcBallast()
{
  // if the pin is high, its a rising edge of the signal pulse, so lets record its value
  if (digitalRead(BALLAST_IN_PIN) == HIGH)
  {
    ulBallastStart = micros();
  }
  else
  {
    // else it must be a falling edge, so lets get the time and subtract the time of the rising edge
    // this gives use the time between the rising and falling edges i.e. the pulse duration.
    unBallastInShared = (uint16_t)(micros() - ulBallastStart);
    // use set the throttle flag to indicate that a new throttle signal has been received
    bUpdateFlagsShared |= BALLAST_FLAG;
  }
}

void calcTrim()
{
  if (digitalRead(TRIM_IN_PIN) == HIGH)
  {
    ulTrimStart = micros();
  }
  else
  {
    unTrimInShared = (uint16_t)(micros() - ulTrimStart);
    bUpdateFlagsShared |= TRIM_FLAG;
  }
}

void calcPiston()
{
  if (digitalRead(PISTON_IN_PIN) == HIGH)
  {
    ulPistonStart = micros();
  }
  else
  {
    unPistonInShared = (uint16_t)(micros() - ulPistonStart);
    bUpdateFlagsShared |= PISTON_FLAG;
  }
}

void calcHydro()
{
  if (digitalRead(HYDRO_IN_PIN) == HIGH)
  {
    ulHydroStart = micros();
  }
  else
  {
    unHydroInShared = (uint16_t)(micros() - ulHydroStart);
    bUpdateFlagsShared |= HYDRO_FLAG;
  }



}

void calcControl()
{
  if (digitalRead(CONTROL_IN_PIN) == HIGH)
  {
    ulControlStart = micros();
  }
  else
  {
    unControlInShared = (uint16_t)(micros() - ulControlStart);
    bUpdateFlagsShared |= CONTROL_FLAG;
  }



}
void calcRoutine()
{
  if (digitalRead(ROUTINE_IN_PIN) == HIGH)
  {
    ulRoutineStart = micros();
  }
  else
  {
    unRoutineInShared = (uint16_t)(micros() - ulRoutineStart);
    bUpdateFlagsShared |= ROUTINE_FLAG;
  }



}




